﻿import sys
import math

from PyQt5.QtCore import pyqtSlot
from PyQt5.QtWidgets import QApplication, QDialog, QMessageBox #objects
from PyQt5.uic import loadUi # pyuic i�in
from PyQt5 import QtCore

def MsgBox(msg):
    msgBox = QMessageBox()
    msgBox.setWindowTitle("Hata olustu !")
    msgBox.setText(msg)
    msgBox.exec_();

def FixedPoint(a, b, n, indis):
    print("*** Fixed Point ***")
    inputVal = 0.0
    counter = 0
    gX = 0.0
    fX = 1.0

    if Fonksiyon(indis, a) * Fonksiyon(indis, b) > 0:
        MsgBox("Kok Bulunamadi")
        return 0 

    while(counter < n and fX != 0):
        gX = TersFonksiyon(indis, inputVal)
        fX = Fonksiyon(indis, inputVal)
        print("i = {0} - x = {1} - gX = {2} - fX = {3}".format(counter + 1, round(inputVal, 5), round(gX, 5), round(fX, 5)))

        inputVal = gX
        counter = counter + 1

    return gX

def Bisection(lower, upper, n, indis):  
    print("*** Bisection ***")
    midPoint = 0.00
    resValue = 0.0

    for c in range(n):
        xU = Fonksiyon(indis, upper)
        xL = Fonksiyon(indis, lower)
      
        midPoint = (upper + lower) / 2        
        resValue = Fonksiyon(indis, midPoint)
                
        if Fonksiyon(indis, midPoint) < 0:
            upper = midPoint
        else:
            lower = midPoint

        print("Lower = {0} - Upper = {1} - MidPoint = {2}".format(round(lower, 5), round(upper, 5), round(midPoint, 5)))
             
    return midPoint


def NewtonRapshen(a, b, n, indis):
    inputVal = 0.0
    farkDelta = 0.0

    for c in range(n):
        fX = Fonksiyon(indis, inputVal)
        tX = TurevFonksiyon(indis, inputVal)
        delta = fX / tX
        farkDelta = inputVal - delta

        yuzde = math.fabs((farkDelta - inputVal) / farkDelta) * 100
        
        inputVal = farkDelta

    return farkDelta

def Secant(x0, x1, n, indis):
    values = []
    values.append(x0) # 0.
    values.append(x1) # 1.
      
    counter = 1
    for c in range(2, n + 2): 
        if  values[c - 2] == values[c - 1]:
            break

        values.append(SecantFinder(indis, values[c - 2], values[c - 1]))
        yuzde = math.fabs((values[c] - values[c - 1]) / values[c]) * 100
        counter = counter + 1

    return values[counter]

def SecantFinder(indis, x0, x1):
    return x1 - (Fonksiyon(indis, x1) * (x1 - x0) / (Fonksiyon(indis, x1) - Fonksiyon(indis, x0)))

def Fonksiyon(indis, x):
    if indis == 0:
        return  math.pow(x, 3) - (2 * x) + 1
    #return x - math.sqrt(x + 6)

def TersFonksiyon(indis, x):
    if indis == 0:
        return (math.pow(x, 3) + 1) / 2
    #return  math.sqrt(x + 6)

def TurevFonksiyon(indis, x):
    if indis == 0:
        return 3 * math.pow(x, 2) - 2

def Hesapla(funcIndis, methodIndis, a, b, n):
    if methodIndis == 0:
        return FixedPoint(a, b, n, funcIndis)
    elif methodIndis == 1:
        return Bisection(a, b, n, funcIndis)
    elif methodIndis == 2:
        return NewtonRapshen(a, b, n, funcIndis)
    elif methodIndis == 3:
        return Secant(a, b, n, funcIndis
                      )
class AnaForm(QDialog):
     def __init__(self, *args):
        super(AnaForm, self).__init__(*args)

        loadUi('main.ui', self)
        self.cmbFunc.addItem("(x ^ 3) - (2 * x) + 1")
      
        self.cmbMethod.addItem("Fixed Point")
        self.cmbMethod.addItem("Bisection")
        self.cmbMethod.addItem("Newton Rapshen")
        self.cmbMethod.addItem("Secant")

     @pyqtSlot()
     def on_btnCalc_clicked(self):
        try:
            a = float(self.txtA.toPlainText())
            b = float(self.txtB.toPlainText())
            n = int(self.txtN.toPlainText())

            result = Hesapla(self.cmbFunc.currentIndex(), self.cmbMethod.currentIndex(), a, b, n)

            self.txtResult.setPlainText(str(result))
            
        except ValueError:
            MsgBox("Degerler yanlis girildi.")

def Main():
    app = QApplication(sys.argv)
    widget = AnaForm()
    widget.show()
    sys.exit(app.exec_())

    
Main()